#! /bin/sh

# Definitionen
##D="-D __DEBUG -D __LANG_EN"
##D="-D __LANG_EN"
D="-D __LANG_DE"

# Pfade
bin="../Bin"
##bin="/home/ftp/hive"
sdplex="${bin}/sdcard/plexus"
sdsys="${bin}/sdcard/system"
libpath="../TriOS/lib"
BSTC="bstc"

# ----------------------------------------------------------------
# Alte Versionen löschen

rm -rf ${sdplex}
rm -rf ${sdsys}/goplexus.bin
mkdir -p ${sdplex}
mkdir ${sdsys}


# ----------------------------------------------------------------
# Code für Administra, Bellatrix und Regime erzeugen

${BSTC} -L ${libpath} ${D} -D __ADM_FAT -D __ADM_FAT_EXT -D __ADM_RTC -D __ADM_SID  -D __ADM_LAN -D __ADM_PLX -D __ADM_DCF -D __ADM_BLT -b -O a ../TriOS/flash/administra/admflash.spin
mv admflash.binary ${sdplex}/plexus.adm

${BSTC} -L ${libpath} ${D} -b -O a source/Plexus-Start-Trios.spin
mv Plexus-Start-Trios.binary ${sdplex}/plexus.bin

${BSTC} -L ${libpath} ${D} -b -O a source/belsVGA64.spin
mv belsVGA64.binary ${sdplex}/plexus.bel

# ----------------------------------------------------------------
# Plexus-Programme erzeugen

${BSTC} -L ${libpath} ${D} -b -O a source/Plexus-Shell.spin
mv Plexus-Shell.binary ${sdplex}/plexus.dll

${BSTC} -L ${libpath} ${D} -b -O a source/Bluetooth.spin
mv Bluetooth.binary ${sdplex}/Bltooth.dll

${BSTC} -L ${libpath} ${D} -b -O a source/Venatrix-Test.spin
mv Venatrix-Test.binary ${sdplex}/Venatrix.dll

${BSTC} -L ${libpath} ${D} -b -O a source/YMODEM-Dll.spin
mv YMODEM-Dll.binary ${sdplex}/YMODEM.dll

${BSTC} -L ${libpath} ${D} -b -O a source/DCF-Test.spin
mv DCF-Test.binary ${sdplex}/dcf.dll

${BSTC} -L ${libpath} ${D} -b -O a source/dos-shell.spin
mv dos-shell.binary ${sdplex}/dos.dll

${BSTC} -L ${libpath} ${D} -b -O a source/sepia-test.spin
mv sepia-test.binary ${sdplex}/sepia.dll

${BSTC} -L ${libpath} ${D} -b -O a source/SignalGenerator.spin
mv SignalGenerator.binary ${sdplex}/Wave.dll

${BSTC} -L ${libpath} ${D} -b -O a source/font-draw.spin
mv font-draw.binary ${sdplex}/font.dll

${BSTC} -L ${libpath} ${D} -b -O a source/Switch_Plexus.spin
mv Switch_Plexus.binary ${sdsys}/goplexus.bin


# ----------------------------------------------------------------
# Daten kopieren

cp -r data/* ${sdplex}
